#!/usr/bin/python

"""Removing QuakeRecord cache files"""

import os, string, sys

if len( sys.argv ) < 2: sys.exit()
if len( sys.argv ) > 2:
    try:
        num = string.atoi( sys.argv[ 2 ] )
    except:
        num = 1000
        pass
    pass
directory = sys.argv[ 1 ]
if os.path.isdir( directory ) == False: sys.exit()
cachefiles = None
for ( path, dirs, filenames ) in os.walk( directory ):
    cachefiles = filenames
    break
if cachefiles == None: sys.exit()
class CacheFile:
    def __init__( self, filename, date ):
        self.filename = filename
        self.date = date
        pass
    pass

def comparator( x, y ):
    if x.date < y.date: return -1
    return 0
        

cachedata = []
for f in cachefiles:
    filename = "%s/%s" % ( directory, f )
    file_in = open( filename )
    line = file_in.readline()
    while line != "":
        if line.find( "Report" ) == 0:
            items = line.strip().split( ":" )
            dts = items[ 1 ].strip().split( "/" )
            dt = [ string.atoi( x ) for x in dts ]
            tm = ( ( ( dt[ 0 ] * 12 + dt[ 1 ] ) * 30 + dt[ 2 ] ) * 24 + dt[ 3 ] ) * 60 + dt[ 4 ]
            cachedata.append( CacheFile( filename, tm ) )
            break
        line = file_in.readline()
        pass
    file_in.close()
    pass

cachedata.sort( comparator )
i = 0
end = len( cachedata ) - num
while i < end:
    os.unlink( cachedata[ i ].filename )
    i += 1
    pass
